from TCPClient import *
from UDPChannel import *
from connectionConsts import *

class connectionClient(TCPClient):
  def __init__(self, ip, port):
    TCPClient.__init__(self, ip, port)
    self.recvFunc = self.__recv
    self.UDPChannels = []

  ### Private methods ###
  
  # The receiving loop
  def __recv(self):
    while not self.stopRecvThread:
      data = self.socket.recv(self.recvBuffSize)
      if data:
        # Remove header
        type, _data = data.split(',', 1)
        type = int(type)
        if type == DATA_UDP_CHANNEL_CREATION:
          _data = int(_data)
          self.UDPChannels.append(UDPChannel('', _data + 1, self.serverAddr[0], _data))
        elif type == DATA_DATA:
          a = self.recvHandler()
          a.handle(_data)
      sleep(self.granularity)

    
